#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;
using SlimDX;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	[PluginInfoAttribute(Name = "Join", Category = "Exhibit", Version = "live")]
	public class JoinExhibitNode : IPluginEvaluate
	{

		[Input("Color")]
		ISpread<RGBAColor> FColorIn;
		
		[Input("Words")]
		ISpread<ISpread<string>> FWordsIn;
		
		[Input("Transformation")]
		ISpread<Matrix> FTransformIn;
		
		[Output("Output")]
		ISpread<Exhibit> FExhibitOut;
		
		// Gets called every frame by vvvv if one of our outputs should
		// provide some data for a node downstream.
		public void Evaluate(int spreadMax)
		{
			// Calculate the maximum slice count
			spreadMax = SpreadUtils.SpreadMax(FColorIn, FWordsIn, FTransformIn);
			FExhibitOut.SliceCount = spreadMax;
			for (int i = 0; i < spreadMax; i++)
			{
				var exhibit = new Exhibit();
				exhibit.Color = FColorIn[i];
				exhibit.Words = FWordsIn[i];
				exhibit.Transformation = FTransformIn[i];
				FExhibitOut[i] = exhibit;
			}
		}
	}
}
